//
//  ToDoItem.swift
//  ToDoServer
//
//  Created by Stephen Freund on 11/18/18.
//  Copyright © 2018 Stephen Freund. All rights reserved.
//

import Foundation

/**
 A ToDoItem is used for both the client and the server
 to represent on task.  Since we have complete control
 over the representation, we can make this be Codable,
 which allows for easier translation to/from JSON.
 */
public struct ToDoItem : Codable {
  
  /// The unique id for this item
  let id : Int
  
  /// The task we must do
  let task : String
  
  /// Whether or not the task is done
  let done : Bool
  
  /// When the item was created.
  let created : String
}
